#include <String.au3>
#include <Array.au3>

Global $fileopendialogLNG, $fileopenLNG, $filereadLNG, $linesplit, $i, $segsplitKEY, $key, $segsplitSL, $sl, $tl, $fullarray, $uniquearraytemp, $arraynumberitems, $returnarray, $k, $j, $keyupdate, $key

Global $countkey, $countsl, $counttl, $countchangedlines, $countalllines
$countkey = 0
$countsl = 0
$counttl = 0
; $countchangedlines = 0
$countalllines = 0

#cs

NOTE: THIS VERSION IS FOR WFC files, so the format is:
sourcetext[tab]targettext[linebreak]
so... two arrays per line

IMPORTANT: Change spans to [[stuff]].

#ce

#cs

Fix Placeables in GTT

Includes code snippet by Realm:
http://www.autoitscript.com/forum/topic/134282-how-to-add-only-unique-items-to-array/

#ce

$fileopendialogLNG = FileOpenDialog ("Select TXT file", @ScriptDir, "All files (*.txt)")
$fileopenLNG = FileOpen ($fileopendialogLNG, 128)
$filereadLNGraw1 = FileRead ($fileopenLNG)

$filereadLNGraw2 = StringReplace ($filereadLNGraw1, " " & @TAB, @TAB)
$filereadLNGraw3 = StringReplace ($filereadLNGraw2, " " & @TAB, @TAB)
$filereadLNGraw4 = StringReplace ($filereadLNGraw3, " " & @CRLF, @CRLF)
$filereadLNG = StringReplace ($filereadLNGraw4, " " & @CRLF, @CRLF)

$linesplit = StringSplit ($filereadLNG, @CRLF, 1)

For $i = 1 to $linesplit[0]

#cs

I suspect this fix only applied to files that used square brackets, but the latest scripts use curly brackets.

If StringInStr ($linesplit[$i], @TAB) Then

; To fix the problem with strings like this: [foo]
; which become [[[foo]]]
; and then become {0/}]
; because the regex is greedy

If StringInStr ($linesplit[$i], "]]]") Then
$linesplit[$i] = StringReplace ($linesplit[$i], "]]]", "]]")
EndIf

If StringInStr ($linesplit[$i], "[[[") Then
$linesplit[$i] = StringReplace ($linesplit[$i], "[[[", "[[")
EndIf

; end fix

#ce

; Since we now use {!LF} for line breaks, we have to fix them before converting the tags

$segsplitKEY = StringSplit ($linesplit[$i], @TAB, 1)

If @error Then
MsgBox (0, "Error, exiting", "Error at $segsplitKEY, perhaps end of file, perhaps blank line, will now exit.", 0)
Exit

$sl = $segsplitKEY[1]
$tl = $segsplitKEY[2]

If StringInStr ($sl, "{{!LF}}", 1) Then
$sl = StringReplace ($sl, "{{!LF}}", "!!!LF!!!")
EndIf

If StringRegExp ($sl, "\{\{.+\}\}", 0) = 1 Then

$fullarray = _StringBetween($sl, '{{', '}}' )
$uniquearray = _ArrayUnique($fullarray )
$arraynumberitems = $uniquearray[0]
 
For $j = 1 to $arraynumberitems
$l = $j - 1
$sl = StringReplace ($sl, "{{" & $uniquearray[$j] & "}}", "{" & $l & "/}")
Next

$countsl = $countsl + 1

EndIf

; TL

If StringInStr ($tl, "{{!LF}}", 1) Then
$tl = StringReplace ($tl, "{{!LF}}", "!!!LF!!!")
EndIf

If StringRegExp ($tl, "\{\{.+\}\}", 0) = 1 Then

$fullarray = _StringBetween($tl, '{{', '}}' )
$uniquearray = _ArrayUnique($fullarray )
$arraynumberitems = $uniquearray[0]
 
For $j = 1 to $arraynumberitems
$l = $j - 1
$tl = StringReplace ($tl, "{{" & $uniquearray[$j] & "}}", "{" & $l & "/}")
Next

$counttl = $counttl + 1

EndIf

$countalllines = $countalllines + 1

$tofileopen = FileOpen ($fileopendialogLNG & ".output.txt", 129)
FileWrite ($tofileopen, $sl & @TAB & $tl & @CRLF)
FileClose ($tofileopen)

Next

MsgBox (0, "Done!", "Processed " & $countalllines & " lines of out " & $linesplit[0] & " lines: " & $countsl & " SLs and " & $counttl & " TLs", 0)
